# Create an API Token Source: https://developer.mindbridge.ai/api-explorer/create-api-token ## Go to the API tab **Note:** Only App Admins can access the API tab. Learn about user roles. 1. Select **Admin** (Admin icon) near the bottom of the MindBridge sidebar on the left side of the screen. You will go to the User Management tab in the Admin settings by default. 2. Go to the **API** tab. You will see a list of API tokens created by your team (if any exist). ## Create a new API token 1. Select **Create token** (located near the top-right corner of the page). You will go to the token creation page. 2. During token creation, provide the following details: * **Name (required):** Enter a unique name for the API token. * **Expiration (required):** Use the menu to choose when the token should expire. * **Permissions (required):** Check the boxes next to the permissions users should have for each endpoint.\ **Note:** The API reference documentation linked on the API tab provides details about each request's basic body and schema. * **Allow list (recommended):** Enter IP address(es) or CIDR that will be allowed to access the MindBridge API. If no restrictions are specified, then no filtering will be applied. 3. When you are satisfied, select **Create token** (located at the bottom-right corner of the page). You will be notified of the token creation status and provided a token ID number to access the MindBridge API. 4. Copy the API token and store it in a secure location. The API token can only be viewed and copied once and cannot be reproduced. If the token number is lost or the token settings need updating, you must create a new token. A given token will remain active until the expiry date, or until it is manually deleted. **Note:** The security of your generated token is paramount, and much like your personal passwords, should never be shared. If a token is compromised, the token must be disabled and re-issued immediately. # Endpoint model Source: https://developer.mindbridge.ai/api-explorer/endpoint-model Endpoints are structured in a standard way: ### Create `POST /{entityName}` - Creates an entity with the properties specified in the request body. ### Read `GET /{entityName}/{entityId}` – Reads the entity identified by the ID. ### Update `PUT /{entityName}/{entityId}` – Updates the entity identified by the ID with the content of the request body. Every time an entity is saved, the `version` property is incremented. To prevent multiple calls from overwriting each other's changes, the `version` property in the updated request body must match the latest version on MindBridge's servers. ### Delete `DELETE /{entityName}/{entityId}` – Deletes the entity identified by the ID. ### Query `POST /{entityName}/query` – Performs a paged query of the entity collection. # Entity model Source: https://developer.mindbridge.ai/api-explorer/entity-model All endpoint requests and responses for a given entity use the same model structure, with some fields being either read-only or editable depending on the method. If a property is not editable for the endpoint in question, it will be ignored. For example, if the following organization entity body is used with the `Create Organization` endpoint, then the `id` property will be ignored and a new organization will be created with a new id and "New organization" as the name. ```json theme={null} { "id": "4b8360d00000000000000001", "name": "New organization" } ``` Using this approach, an entity can be created or updated using the same model read from a read entity call, as read-only fields will not be overwritten by changes made to the *create* or *update* body. If a property that is not present on the model is included in a create or update request, then the request body will be considered invalid and an error will be returned. # Export Source: https://developer.mindbridge.ai/api-explorer/export-open-api-specification # Overview Source: https://developer.mindbridge.ai/api-explorer/info-description The MindBridge API is an HTTP REST API that provides access to MindBridge entities and processes. Request and response bodies are generally JSON formatted, with some exceptions. # MindBridge Query Language Source: https://developer.mindbridge.ai/api-explorer/mindbridge-query-language ### Overview MindBridge Query Language (QL) is the standard unified query language used to interact with all the underlying data tables and collections within MindBridge. This query language has been extended to the MindBridge API, which uses this syntax for all `/query` endpoints within the API, as well as several other endpoints. ### Syntax The query is expressed as a JSON object. The example below looks for values equal to 10000 in the `credit` column. ```json theme={null} { "credit": { "$eq": 10000 } } ``` Above, `$eq` is the equality operator. Other operators are listed below. As a shortcut for equality, you can specify the value directly. ```json theme={null} { "credit": 10000 } ``` In order to conform to the syntax of a valid JSON object, all operators and fields must be enclosed in quotes. For more details on the JSON language, refer to [json.org](https://json.org). Logical `AND` and `OR` conditions are available. If you want to specify two columns, the conditions can be combined with `$and`. ```json theme={null} { "$and": [ { "account": { "$eq": "1023345" } }, { "risk": { "$gte": 5000 } } ] } ``` #### Simplified Syntax The example `$and` query above can be simplified using the syntax seen below. ```json theme={null} { "account": { "$eq": "1023345" }, "risk": { "$gte": 5000 } } ``` You can combine `$or` and `$and` to build up a more complex structure, such as the one seen below, which combines all the techniques seen so far. ```json theme={null} { "risk": { "$gte": 5000, "$lt": 7000 }, "$or": [ { "transaction": { "$iprefix": "ABC1" } }, { "transaction": { "$iprefix": "ABC2" } } ], "$and": [ { "source": { "$ne": "MA" } }, { "source": { "$iprefix": "M" } } ] } ``` You can use two operators on the same column at the same time: ```json theme={null} { "credit": { "$gte": 1000, "$lt": 10000 } } ``` #### Unique Names Every field in a JSON object or sub-object must be **unique**. The following is not valid because `source` appears twice at the top level. ```json theme={null} { "source": { "$ne": "MA" }, "source": { "$ne": "MB" } } ``` Instead, wrap it in `$and`: ```json theme={null} { "$and": [ { "source": { "$ne": "MA" } }, { "source": { "$ne": "MB" } } ] } ``` Or use another operator like `$nin`: ```json theme={null} { "source": { "$nin": [ "MA", "MB" ] } } ``` You can use two operators on the same column at the same time: ```json theme={null} { "credit": { "$gte": 1000, "$lt": 10000 } } ``` ### Column Operators **Column operators** apply a filter to a specific column. | Description | Description | Column Types | Field Conditions | | - | - | - | - | | `$eq` | Tests if the value in the column **is identical** to the literal value. | STRING
DATE\_TIME
INT32
INT64
FLOAT32
FLOAT64
MONEY\_100
PERCENTAGE\_FIXED\_POINT
OBJECT\_ID | case-insensitive on STRING values
`equalitySearch` must be true | | `$ne` | Tests if the value in the column **is not identical** to the literal value. | STRING
DATE\_TIME
INT32
INT64
FLOAT32
FLOAT64
MONEY\_100
PERCENTAGE\_FIXED\_POINT
OBJECT\_ID | case-insensitive on STRING values
`equalitySearch` must be true | | `$gt` | Tests if the value in the column is **greater than** the literal value. | STRING
DATE\_TIME
INT32
INT64
FLOAT32
FLOAT64
MONEY\_100
PERCENTAGE\_FIXED\_POINT
OBJECT\_ID | case-insensitive on STRING values
`rangeSearch` must be true | | `$gte` | Tests if the value in the column is **greater than or equal** to the literal value. | STRING
DATE\_TIME
INT32
INT64
FLOAT32
FLOAT64
MONEY\_100
PERCENTAGE\_FIXED\_POINT
OBJECT\_ID | case-insensitive on STRING values
`rangeSearch` must be true | | `$lt` | Tests if the value in the column is **less than** the literal value. | STRING
DATE\_TIME
INT32
INT64
FLOAT32
FLOAT64
MONEY\_100
PERCENTAGE\_FIXED\_POINT
OBJECT\_ID | case-insensitive on STRING values
`rangeSearch` must be true | | `$lte` | Tests if the value in the column is **less than or equal** to the literal value. | STRING
DATE\_TIME
INT32
INT64
FLOAT32
FLOAT64
MONEY\_100
PERCENTAGE\_FIXED\_POINT
OBJECT\_ID | case-insensitive on STRING values
`rangeSearch` must be true | | `$contains` | Tests if an array **contains** a literal value.
For example, given a transaction with entries from accounts 12345 and 23456, the following query on the `gl_journal_tx` data table would match the transaction:
`{ "accounts": { "$contains": "12345" } }` | ARRAY\_STRINGS | case-insensitive on STRING values
`containsSearch` must be true | | `$ncontains` | Tests if an array **does not contain** a literal value. | ARRAY\_STRINGS | case-insensitive on STRING values
`containsSearch` must be true | | `$in` | Tests if a column is equal to one of the values in an array of literals. | STRING
DATE\_TIME
INT32
INT64
FLOAT32
FLOAT64
MONEY\_100
PERCENTAGE\_FIXED\_POINT
OBJECT\_ID | case-insensitive on STRING values
`equalitySearch` must be true | | `$nin` | Tests if a column is **not equal** to any values in an array of literals. | STRING
DATE\_TIME
INT32
INT64
FLOAT32
FLOAT64
MONEY\_100
PERCENTAGE\_FIXED\_POINT
OBJECT\_ID | case-insensitive on STRING values
`equalitySearch` must be true | | `$flags` | Accepts an object with one or more keys with boolean values. Tests if the flags (keys) match the values.
For example, to search for entries that triggered the [2 Digit Benford](https://support.mindbridge.ai/hc/en-us/articles/360056059834) control point, use this query on the `gl_journal_lines` data table.
`{ "cp_failed": {"$flags": { "journal_entry_two_digit_benford": true }}}` | BOOLEAN\_FLAGS | | | `$isubstr` | Tests if a literal value **matches** the value in the column. For example, the following query on the `engagements/query`
endpoint will match engagements named "abc", "aBc", and "zabcd".
`{ "name": { "$isubstr": "abc" } }` | STRING | case-insensitive on STRING values
`allowCaseInsensitiveSubstringSearch` must be true | | `$iprefix` | Tests if a literal value **matches** the start of the value in the column. For example, the following query on the `gl_journal_tx` data table will match transactions "T1234", "t1234", and "T12345".
`{ "transaction": { "$iprefix": "T1234" } }` | STRING | case-insensitive on STRING values
`caseInsensitivePrefixSearch` must be true | | `$niprefix` | Tests if a literal value **does not match** the start of the value in the column. | STRING | case-insensitive on STRING values
`caseInsensitivePrefixSearch` must be true | ### Root Operators #### Logical Operators **Logical operators** allow MindBridge to combine Column Operation queries to allow for more sophisticated calls. | Operator | Description | | - | - | | `$and` | Tests that **all** contained terms are evaluated to be `true`. | | `$or` | Tests that **any** contained terms are evaluated to be `true`. | #### Keyword Operators **Keyword operators** are applied simultaneously to all columns that support keyword searches. This is controlled by the keywordSearch attribute associated with the column’s metadata. | Operator | Description | | - | - | | `$keyword_prefix` | Performs a case-insensitive prefix search of all words in the row (operand must be a STRING).
For example, the following query on the `gl_journal_tx` data table will return transactions with rows that contain the words **abc** , **abcdef**, or **aBcd** in any column.
`{ "$keyword_prefix": "abc" }` | | `$keyword_prefix_not` | Inverted case-insensitive prefix search (operand must be a STRING). | #### Population Operators **Population operators** test whether the specified entry is or is not included within the specified population, identified by its ID. The population in question must be accessible from the analysis, meaning the population must be part of the analysis, engagement, or library that this data table resides in. | Operator | Description | | - | - | | `$population` | Tests that entries are part of the population specified by the provided ID. | | `$not_population` | Tests that entries are not part of the population specified by the provided ID. | The correct usage of `$population` and `$not_population` is as follows, with `643eff00ec992f7ec42ed9f7` being a valid population ID: ```json theme={null} { "$population": "643eff00ec992f7ec42ed9f7" } ``` ```json theme={null} { "$not_population": "643eff00ec992f7ec42ed9f7" } ``` ### Data Formats Because the MindBridge QL is based on JSON, `strings`, `numbers`, and `booleans` are natively included in the language definition, but other values require some conversion. The following table describes the values MindBridge QL accepts in relation to our internal data structure. The contents of the "Column Type" column (below) represent the data types supported internally and how they are mapped to the JSON object structure. | Column Type | Format | | - | - | | `STRING` | Value must be a JSON string. | | `DATE_TIME` | A JSON string in ISO8601 date-time format, such as **2019-08-10T00:50:00Z**. | | `BOOLEAN` | Value must be a JSON boolean (true or false). | | `INT32` | Value must be a JSON number in the range **\[-2^31, 2^31-1]**. | | `INT64` | Value must be a JSON number in the range **\[-2^63, 2^63-1]**. | | `FLOAT32, FLOAT64` | Value must be a JSON number.
FLOAT32 **\[1.2E-38, 3.4E+38]**
FLOAT64 **\[2.2E-308, 1.7E+308]** | | `MONEY_100` | Currently we express currency values as integers, essentially multiplying by 100 to store, and dividing by 100 when displaying the value.
This allows MindBridge to operate with floating point numbers without loss of precision. Value must be a JSON number in the range **\[-2^63,2^63-1]**. No division by 100 is performed on the actual data.
For example, in a `MONEY_100` column, such as credit, the following query on the `gl_journal_lines` data table will find values greater than 1234.
`{ "credit": { "$gt": 1234 } }` | | `PERCENTAGE_FIXED_POINT` | Value must be a JSON number in the range **\[0, 10000]** where 10000 means 100%. | | `ARRAY_STRINGS` | Value must be an array of JSON strings. | | `OBJECT_ID` | A 12-byte database identifier, represented by a 24-character hexadecimal string. Organizations, engagements, analyses, and analysis sources all use **OBJECT\_ID** for their `id` fields.
For example, `6686add55cd5c94147ecebdb` | # MindBridge API Source: https://developer.mindbridge.ai/api-explorer/overview The MindBridge Application Programming Interface (“API”) allows you to control permissions and access to various aspects of your MindBridge tenant, including libraries, organizations, engagements, and analyses. With the API, you can securely push files from your ERP directly into the file manager, import the data into an analysis, and run the analysis — all from outside the MindBridge app. Then, just hop into MindBridge to view the analysis results. # Prerequisites You must be an App Admin to access the API page within the MindBridge application. # How does an API work? An API allows an application to communicate with the MindBridge app through a set of clearly defined commands, enabling secure access to enterprise assets and processes using a REST interface. As displayed in the image below, using an API is similar to placing an order at a restaurant. Think of API commands as ordering off a restaurant menu — the menu defines a list of available "dishes" (like programs or functions), and when you place an order, the kitchen (like the server or database) prepares the food (like the request) in the back, then sends it out to you when it is ready. In brief, APIs define a list of commands. When an ERP uses one of those commands, MindBridge sends back what was requested. Diagram illustrating how an API works. # What is a REST architecture? MindBridge uses a RESTful API architecture, which allows computer systems to exchange information securely over the internet utilizing HTTPS. Requests made via a RESTful API are stateless, and each request contains all of the data necessary to complete the request successfully. # What are the benefits of using an API? * Scalable data ingestion and exporting results using automation * A unified data analysis platform, regardless of industry or organization needs * Secure and controlled access to MindBridge’s data which creates new opportunities for analysis and insights at scale * The automation of complex, repeatable tasks # What is a MindBridge API token? A MindBridge API token is a string of characters that acts as a key to the API, and is implemented as an authentication bearer token. It is utilized by adding the token to the header of each HTTPS request. This token type is a cryptographically secure authentication token that includes the configured permissions allowing API clients to access MindBridge API resources or "endpoints". # What is an endpoint? Endpoints are exposed functions of an application API with functionality provided by HTTPS methods. # What is an HTTPS method? An HTTPS method represents functionality supported by the HTTPS protocol, such as GET, POST, PUT, PATCH, and DELETE. These methods essentially allow you to read, write, or delete libraries, organizations, engagements, analyses, users, and much more. # How long do API tokens last? The token life cycle is configurable by the App Admin for any period of time, up to a maximum of 2 years. # What happens if my API token is compromised? Tokens must be stored in a secure location, and should never be shared. The security of your token is paramount. If a token is compromised, the App Admin should disable and re-issue the token immediately. # How are API tokens generated? An App Admin creates API tokens in the Admin section of the app, where they can apply lifecycle and permissions to each token. Learn how to create a MindBridge API token [here](/api-explorer/create-api-token). # Who can access and use the API? Anyone who has a valid token is able to use the API. App Admins are responsible for managing API tokens, and can grant API access to any users within the engagement. # How do I use the API? To use the API: 1. An API token must be generated by an App Admin within MindBridge. 2. Once you have access to the API token, use the HTTPS protocol to make a request to a documented endpoint in the MindBridge API. Requests can be made using a variety of tools, including most programming languages. In order to utilize a token generated within the MindBridge platform, you must add the following to the header of each HTTPS request: ```text theme={null} Authorization: Bearer {token} ``` # What is the format for communicating with the API? The API utilizes JSON for all request and responses, with the exception of data files, which can be imported in any format supported within the application. # What file formats are accepted through the API? All file formats currently supported by the file manager will be accepted, such as .xlsx, .csv, and more. # What files can I push or pull through the API? ## Inbound All files currently supported by the MindBridge platform can be pushed through the API. Files can be assigned to any of the sources within an analysis, such as the "General Ledger" slot. ## Outbound The API supports paginated analysis results, indexed by transactions, or entries as well. The data available is equivalent to the data table in the MindBridge platform. # Quick Start Source: https://developer.mindbridge.ai/api-explorer/quick-start ## Overview Below are common API workflows and related Knowledge Base articles (requires being logged into MindBridge). * Create a new organization, or find the organization ID of the organization you want to work in [↗](https://support.mindbridge.ai/hc/en-us/articles/9664889181847-Get-an-organization-ID-for-an-existing-organization) * Create a new engagement, or find the engagement ID of the engagement you want to work in [↗](https://support.mindbridge.ai/hc/en-us/articles/9678608725783-Get-an-engagement-ID-for-an-existing-engagement) * Create a new analysis, or find the analysis ID of the analysis you want to work in [↗](https://support.mindbridge.ai/hc/en-us/articles/9680904374295-Get-an-analysis-ID-for-an-existing-analysis) * Load your files into the File manager * Import your files into a target analysis * Run the analysis * Prepare to get the data table results by finding the unique data table ID [↗](https://support.mindbridge.ai/hc/en-us/articles/9683888113431-Get-a-data-table-ID-for-a-specific-analysis) * Get the results from the data table [↗](https://support.mindbridge.ai/hc/en-us/articles/9758842964887-Get-the-data-table-results-for-a-specific-analysis) # Rate limiting Source: https://developer.mindbridge.ai/api-explorer/rate-limiting **Rate limiting** restricts the number of API calls that can be made to certain endpoints over a given period of time, and has been applied to the endpoints indicated below. Once the limit is reached, further calls to any of these endpoints will fail until the rate limit resets. These failures will show the HTTP status: `429 Too Many Requests`, along with a response header: `X-User-Hour-Limit-Remaining`. The value in the response header represents the number of seconds until the rate limit resets. For example, suppose the `POST /users` endpoint has a rate limit of `100` calls per `1 hour`. If more than 100 requests are made within the given hour, any subsequent requests would fail and return the error indicated above. Since rate limiting is applied tenant-wide, all tokens share the same rate limit. ### Rate limits | Name | Reset time remaining header | Limit | Duration | Endpoints | | - | - | - | - | - | | Modify users rate limit | `X-User-Hour-Limit-Remaining` | 100 | 1 hour | - Create user
- Update user
- Resend activation email | ### Platform-level rate limits Additional rate limits are applied at the platform level on a per-IP address basis to protect against potential abuse or client-side software incidents, and are set high enough that customers should not encounter them in regular use. Platform-level rate limits will return the HTTP status `429` with no `X-User-Hour-Limit-Remaining` header, and requests can be retried after approximately 30 seconds. # Security Source: https://developer.mindbridge.ai/api-explorer/security # How is MindBridge securing my data? MindBridge secures your data through: * Access through API tokens (bearer tokens) * Encryption * Rate limiting and prevention of distributed denial-of-service (DDoS) attacks * Leveraging existing security measures to maintain ISO 27001 and SOC 2 Type 2 compliance # What kind of permissions can be applied to each token? Each token has scoped access options for specific areas of MindBridge and permitted actions within those areas. Examples include: * `api.organizations.read` — Grants read access to organizations * `api.organizations.write` — Grants write access to organizations * `api.tasks.write` — Grants write access to tasks * `api.engagements.delete` — Grants delete access to engagements # Can tokens be revoked or re-issued? Tokens can be deleted at any time. While tokens can be renewed, this action does not re-use the existing token, but instead copies the existing settings into a new token. # Can users be deactivated after they have been granted access to the API? App Admins can delete tokens within the application. # How are permissions configured? App Admins can set specific permissions for each token based on user roles, allowing certain aspects of the API to be accessible to some users while restricted for others. **Note:** Tokens must be stored securely. # Account Groupings Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/account-groupings An **account grouping** is a custom financial hierarchy that MindBridge uses to interpret accounts and the relationships between them, and defines how accounts are aggregated and presented in analysis results across the MindBridge platform and reports. When you create an account grouping, you must map account groups to [MindBridge Account Classification (MAC) codes](https://support.mindbridge.ai/hc/en-us/articles/22819163288343-MindBridge-Account-Classification-code-system-MAC-v-2). This mapping enables MindBridge to effectively analyze datasets across any engagements and analyses that use a given account grouping. ## Creating a new account grouping To create a new account grouping, import a completed [MACv2\_AccountGroupingTemplate](https://support.mindbridge.ai/hc/en-us/articles/22819163288343)\* Excel file or a *CCH group trial balance* file as a chunked file. Import the new file using the `/import-from-chunked-file` endpoint. This action will create a new account grouping entry and a complete set of account groups and MAC mappings, as defined in the imported file. \***Note:** The exportable template is located at the bottom of the linked article. Once you have the template, follow the steps linked here to [create a new account grouping](https://support.mindbridge.ai/hc/en-us/articles/360056330754). ## Appending to an existing account grouping To append to an existing account grouping, export the most current version of your MindBridge account grouping, then add new account groups to the bottom of the account grouping, starting from the first empty row. Next, save the file and import it as a chunked file, then import the new file using the `/append-from-chunked-file` endpoint. This action will add the new account groups and mappings to the end of the existing account grouping. **Note:** *CCH group trial balance* files may not be used when appending to an existing account grouping. ## Publishing an account grouping Account groupings must be published before they can be added to a library. In order to be published, errors must be resolved for all account groups within the account grouping, and the lowest-level account categories for each account group must be mapped to a MAC code. To publish an account grouping, set the `publishStatus` field to `PUBLISHED`. Upon publishing, all the account groups within the account grouping are finalized and can no longer be updated, however the account grouping can still be appended to. Appending will change the account grouping’s `publishStatus` to `UNPUBLISHED_CHANGES`. From the `UNPUBLISHED_CHANGES`, the account grouping can be re-published after fixing all account group errors, then updating the `publishStatus` field to `PUBLISHED`. # Account Groups Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/account-groups An **account group** is an individual entry within an account grouping. The lowest-level category for each account group must be mapped to [MindBridge Account Classification (MAC) codes](https://support.mindbridge.ai/hc/en-us/articles/22819163288343-MindBridge-Account-Classification-code-system-MAC-v-2), and optionally, assigned account tags for further classification. Account groups can be updated as needed until the account grouping is published. Once published, existing account groups cannot be updated, but new account groups can be added to the account grouping using the `append` endpoint. # Account Mappings Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/account-mappings *Account mapping* aligns your organization's accounts with MindBridge Account Classification (MAC) codes based on their nature, ensuring that MindBridge can consistently and effectively analyze datasets across the engagement. Before an analysis can be run, all account mappings within the given engagement must be marked as *Verified* or *MAC code*. ## Mapping statuses * **Verified**: Indicates that the account has been mapped to a MAC code or grouping code *automatically*, and/or was previously manually verified. * **Unverified**: Indicates that MindBridge *automatically* mapped the account to a lowest level account grouping code based on the grouping code and/or account description, and should be verified for accuracy before you proceed. * **MAC code**: When using a MindBridge default library, this indicates that the imported general ledger file included a "MAC code" column that accurately reflects the lowest-level MAC code for each account group in the ledger — in this case, MindBridge uses *direct matching* to map the accounts. * **Modified**: Indicates that an account's MAC code was updated when copied between account groupings — this may happen if a *different library* is selected while rolling an analysis forward or duplicating an analysis into a *new engagement*. * **Manual**: Indicates that the account mapping was changed manually by a member of your team. * **Inferred**: When a less granular grouping code or MAC code is provided, this indicates that MindBridge has automatically mapped the account to a Level 3 MAC code based on the provided code and account description, and should be verified for accuracy before you proceed. * **Unmapped**: Indicates that the account has not yet been mapped to a valid MAC code or grouping code. # Admin reports Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/admin-reports **Admin reports** are reports that can be run to summarize user and system activity. Currently, the following reports can be run: * **Activity report** – This report lists activity between the specified dates and filters * **Analysis overview report** – This report lists analyses and the associated risk score results. * **Row usage report** – This report lists analyses completed within your specified date range along with the number of rows in each primary current period data file. # Analyses Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/analyses An **analysis** is a logical grouping of financial data that can be run through a series of rules-based, statistical, and machine-learning tests in order to generate analysis results. Once a set of financial data has been configured and imported, an analysis can be run to produce an *Analysis Result* entity, which contains insights into the provided data. Analyses require a number of supporting documents in order to run successfully. After running an analysis, you can view the results and leverage them to support your audit work. ### Analysis Type When creating an analysis, you must identify the **type of analysis** you want to create. To do so, set the `analysisTypeId` field to the corresponding ID for the specific analysis type. The analysis type must be supported by the library used by the engagement. The supported analysis types are listed in the library’s `analysisTypeIds` field. Refer to the Analysis Type endpoint to select an analysis type and review its settings. ### Analysis Periods An **analysis period** is the date range for a given period under analysis. MindBridge supports the analysis of one current period and up to four prior periods. To add analysis periods, add analysis period objects to the appropriate locations in the `analysisPeriods` array. To modify analysis periods, update the `analysisPeriods` array. **Note**: Analysis periods will appear in order, with the most recent appearing in the current period. Periods must not overlap or have date gaps between them. The `interimAsAtDate` must not be set for prior periods. To resize an analysis period, update the `startDate`, `interimAsAtDate` and/or `endDate` to the desired date. See “Interim Time Frames” below for details. To remove an analysis period, remove the target object in the `analysisPeriods` array. The current period (index `0`) may not be removed, nor analysis periods that have associated analysis sources. If you remove the ID from an analysis period, the analysis period will be removed and a new period with the same values will be added, resulting in a new ID being returned. [Learn more about analysis periods](https://support.mindbridge.ai/hc/en-us/articles/360056524494-What-is-an-analysis-period) #### Full Time Frames The **full time frame** allows your team to import a complete dataset. [Learn more](https://support.mindbridge.ai/hc/en-us/articles/19029762802967) To create an analysis with a full time frame, the `interim` and `periodic` fields must be `false` in the body of the Create Analysis request. #### Interim Time Frames The **interim time frame** allows your team to import a portion of a dataset before year-end. [Learn more](https://support.mindbridge.ai/hc/en-us/articles/19030451443223) To create an analysis with an `interim` time frame, the interim field must be `true` in the body of the Create Analysis request. You must also provide an `interimAsAtDate` for the current period, which defines the last day of the interim period. **Note**: The `interim` field cannot be combined with the `periodic` field, which must be `false` if `interim` is `true`. **Note**: The interim time frame must be supported by the analysis type in order to use it. #### Periodic Time Frames The **periodic time frame** allows your team to import data on an ongoing basis, such as monthly or quarterly, over the course of the analysis period. [Learn more](https://support.mindbridge.ai/hc/en-us/articles/19034004957591) To create an analysis with a periodic time frame, the `periodic` field must be `true` in the body of the Create Analysis request. **Note**: The `periodic` field cannot be combined with the `interim` field, which must be `false` if `periodic` is `true`. **Note**: The periodic time frame must be supported by the analysis type in order to use it. Additionally, the periodic time frame and the risk monitoring dashboard are disabled by default in the library's analysis configuration, and must be enabled by an App Admin before they can be accessed. ### Currency The **currency code** indicates the type of currency used in the analysis. A valid currency code must be provided in the `currencyCode` field. **Note**: MindBridge supports the majority of currencies indicated in [ISO 4217](https://www.iso.org/iso-4217-currency-codes.html). Currency code labels used within MindBridge may not match ISO labels exactly, but support for those currencies still exists. **Note**: MindBridge does not support currencies that use more than two decimal places. ### Reporting Periods MindBridge supports custom reporting periods. If your organization has a custom reporting period configuration, you can specify it when creating an analysis by providing the `reportingPeriodConfigurationId` field with the ID of the desired reporting period configuration. If no reporting period configuration ID is provided, it inherits the reporting period set in the engagement. On an update, the existing value will be used if no value is provided. # Analysis Results Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/analysis-results An **analysis result** is a logical grouping of financial data that has been run through a series of rules-based, statistical, and machine-learning tests. Each time an analysis is run (or re-run), it will generate a distinct analysis result. Running an analysis multiple times will result in multiple sets of analysis results. ### Task and data table migration for the periodic time frame When an analysis using the *periodic* time frame is re-run, any existing tasks or data tables created on the latest analysis result will be migrated to the new analysis result. Upon completion, the `id` field will be updated to a new value, and the `analysisResultId` field will be updated with the ID of the new analysis result. **Note**: This does not apply to *full* or *interim* time frames, wherein rolling forward, duplicating, or converting interim analyses causes a new analysis being created, with the original analysis results' tasks and data tables remaining in place. # Analysis Source Types Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/analysis-source-types An **Analysis Source Type** describes the features applied when importing an analysis source, such as the effective date range, transaction ID selection, etc., as well as relevant MindBridge column definitions. These features determine which steps occur during the analysis source import process. ### Alternative MindBridge field names for non-MAC account groupings When using a non-MAC based account grouping, some MindBridge fields use a different name (for example, `mac_code` becomes `custom_code`). This is identified by the `mindbridgeFieldNameForNonMacGroupings` field, which describes which MindBridge field name to use instead. Additionally, when using a non-MAC based account grouping, some fields may become required. This is indicated by the `requiredForNonMacGroupings` field, which is set for all fields that specify a `mindbridgeFieldNameForNonMacGroupings` value. # Analysis Sources Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/analysis-sources An **analysis source** represents a table of data (often from a file) that is required to run an analysis. These objects contain ingestion metadata, including data formats, density and frequency analysis, and much more. The analysis sources are the core object types used during the data import process and provide the data necessary to complete the analysis. ### Analysis source type An **analysis source type** determines which features are available during the analysis source import process, and must be selected when creating an analysis source. Refer to the `Analysis Type` endpoint to determine which analysis source types can be applied to a given analysis. Refer to the `Analysis Source Type` endpoint to determine the features and column mappings for a given analysis source type. #### Additional Analysis Data **Additional data** is available as an analysis source type for all analysis types. When creating an additional data analysis source, the `additionalDataColumnField` property must be set to the additional data field added during the import of other source types. A list of the analysis' additional data columns is available from its `importantColumns` field. ### Async create and update responses Unlike other entities, the analysis source entity may perform long-running background jobs as a result of a `Create` or `Update` call. As a result, calls to `Create` or `Update` an analysis source will return an **async result** entity. Users should poll this entity and await its completion before re-loading the analysis source and making further changes. ### Analysis Source workflow Unlike other entities, importing an analysis source relies on a multi-step workflow process. Which steps are included is determined by which **features** the analysis source type supports. These features include multiple **workflow states**, which determine the current location of the analysis source within the workflow. There are two workflow state types: **step states** and **transition states**. * Step states allow users to configure properties on an analysis source, or the analysis more broadly. Some step states are provided for the MindBridge web app interface and may have little to no meaningful interaction with the API. * Transition states indicate that the analysis source is performing work asynchronously, and will eventually transition to another state. Here is a list of features and their possible workflow states: | Feature | State name | State type | | - | - | - | | Feature independent | STARTED | Transition | | Format detection | DETECTING\_FORMAT | Transition | | | FORMAT\_DETECTED | Step | | | FORMAT\_DETECTION\_COMPLETED | Transition | | Data validation | ANALYZING\_COLUMNS | Transition | | | COLUMNS\_ANALYZED | Step | | Column mapping | DATA\_VALIDATION\_CONFIRMED | Step | | | COLUMN\_MAPPINGS\_CONFIRMED | Transition | | Effective date metrics | ANALYZING\_EFFECTIVE\_DATE\_METRICS | Transition | | | EFFECTIVE\_DATE\_METRICS\_ANALYZED | Step | | | ANALYSIS\_PERIOD\_SELECTED | Transition | | Transaction ID selection | CHECKING\_INTEGRITY | Transition | | | INTEGRITY\_CHECKED | Step | | Parse | PARSING | Transition | | | PARSED | Step | | Review Funds | FUNDS\_REVIEWED | Step | | Confirm Settings | SETTINGS\_CONFIRMED | Transition | | Feature independent | COMPLETED | Step | | | FAILED | Step | ### Transitioning between states To transition between workflow states, set the `targetWorkflowState` property to the name of the desired workflow state. Once set, the workflow will attempt to advance to that state, passing through all states between the current and target state without stopping. If the target state is a transition state, the workflow will continue past it until it reaches the next step state. When creating a new analysis source, if `targetWorkflowState` is not set, the workflow will advance to the first valid step state, then stop. These rules apply to all transitions, with a few exceptions: * If an [ungrouped format](https://support.mindbridge.ai/hc/en-us/articles/10437018464407) is detected within the selected source file, the FORMAT\_DETECTED state will be ignored. Setting `targetWorkflowState` to FORMAT\_DETECTED on a source file containing ungrouped data will result in the workflow continuing to the next step state. * If the final workflow state type is a step state, the workflow will advance to COMPLETED instead of stopping. This is often the case with the PARSED state, as it is the final feature state for many source types. * If an error occurs during a workflow process, the workflow will transition to FAILED. The cause of the failure can often be found in the async result or in the analysis source’s `errors` property. ### Feature properties Certain feature properties may only be read or set on or after specific workflow states. Here is a breakdown of the relationship between workflow states and analysis source properties: #### Format detection If a [grouped data](https://support.mindbridge.ai/hc/en-us/articles/10437018464407) format is detected, the workflow will stop at the FORMAT\_DETECTED state. Then, the `detectedFormat` property will return the name of the detected format. From there, the `applyDegrouper` can be set. If `applyDegrouper` is true then when advancing to the next step, the relevant formatter will be used to convert the file into a readable format. If not, the file will be used as is. `applyDegrouper` can be set immediately upon creation of the analysis source. If this is done and grouped data is detected within the workflow, instead of stopping on FORMAT\_DETECTED it will implicitly apply the formatter and continue to the next workflow state. If the formatter is used in either scenario, the `degrouperApplied` property will be set to `true`. The `presetHeaderRowIndex` field can be set to manually specify the header row’s position in the imported file, bypassing automatic header detection. The field is zero-based, so the first row in the file is considered row 0. #### Data validation Upon reaching the COLUMNS\_ANALYZED state, the `fileInfo` property is populated with information, including metadata for the individual columns (which is available as part of the `columnData` property) and for the file as a whole (available under the `metadata` property). Metrics contain a `state` property, which may appear as `PASS`, `WARN`, or `FAIL`. These serve as status indicators and may warn of problems with the file’s data. #### Column mapping Upon reaching the DATA\_VALIDATION\_CONFIRMED state, the `proposedVirtualColumns`, `proposedColumnMappings`, and `proposedAmbiguousColumnResolutions` properties are applied, and the `virtualColumns`, `columnMappings`, and `ambiguousColumnResolutions` properties are updated accordingly. More information on the proposed fields is available in the **Full source import automation** section. If no value is present for `proposedColumnMappings`, then a set of recommended column mappings will be applied to the file. The API handles column mapping by assigning a column from the file to a MindBridge field with a compatible data type. To do this, an entry in the `columnMappings` array must contain both the `position` of the column from the source file and the target `mindbridgeField` to assign it to. #### Virtual columns [Virtual columns](https://support.mindbridge.ai/hc/en-us/articles/10442701235223) can be added, modified, and removed by changing the `virtualColumns` property. Once created, virtual columns have a `position` property that can be used in column mapping; the metrics in `fileInfo` will be updated accordingly. #### Ambiguous column resolution While MindBridge can detect usable date formats, including different formats that appear within a single column, in some cases the format of date and currency fields cannot be determined from the dataset provided. For example, the date format `1/2/2022` could either be January 2nd, 2022, or February 1st, 2022, depending on which date format is being used. When ambiguous columns are detected, an entry in the `ambiguousColumnResolutions` property will be created with a list of all the possible formats in its `ambiguousFormats` property. To resolve this issue, the correct format from the list of `ambiguousFormats` should be set in the `selectedFormat` property. #### Additional data Unmapped columns may be added as additional data columns. To do so, a special mapping must be created with the `mindbridgeField` left blank, and a value set for `additionalColumnName`. Once this source has completed the import process, a new source with the same name set for `additionalDataColumnField` and the source type ID corresponding to the Additional Data Source Type can be created. #### Effective date metrics This step confirms that the file’s entries fall within the current analysis period. Once this state has been reached, the `analysis-sources/{analysisSourceId}/effective-date-metrics` endpoint can be used to get a set of metrics regarding the number of entries within the source’s analysis period. A `period` value can be used to set the resolution of the histogram to days, weeks, or months. #### Transaction ID selection Transitioning into the [transaction ID](https://support.mindbridge.ai/hc/en-us/articles/8740577590295) selection feature will generate a preview of the selected transaction by `proposedTransactionIdSelection` and set the `transactionIdSelection` property to this value. If no value is set, a set of potential transaction ID selections will be generated and what is determined to be the best selection, according to MindBridge's internal tooling, will be set to the `transactionIdSelection` property. Details about these **transaction ID previews** can be viewed via the transaction ID preview endpoints. When on the INTEGRITY\_CHECKED state, changing the `transactionIdSelection` will either select an existing preview with the same properties as the currently selected transaction ID, or, if it doesn’t exist, will generate a new preview for the selection, and select it. #### Review funds and confirm settings These features have no direct interaction with the API and are only relevant with respect to the web application. ### Full source import automation When creating a new analysis source it is possible to perform the entire import process by setting the `targetWorkflowState` property to `COMPLETED`. As a result of performing all workflow steps at once, some features require input to be provided immediately, specifically the column mapping and transaction ID selection features. To provide these values, separate `proposed` fields can be set in order to provide these values instead of relying on the default column mapping and transaction ID selection behavior. #### Column mapping The `proposedVirtualColumns`, `proposedColumnMappings`, and `proposedAmbiguousColumnResolutions` properties provide the ability to pre-define their respective properties ahead of running validation. These proposed versions of the properties have some key differences from their applied counterparts: * As validation has not been run and the column positions have not been determined, the `position` property for virtual columns isn’t available. As an alternative to the `proposedColumnMappings` property, a `virtualColumnIndex` property is available and should be used to reference a specific virtual column definition in the `proposedVirtualColumns` array. * `proposedAmbiguousColumnResolutions` are not able to determine the ambiguous formats ahead of validating the file, so the `ambiguousFormats` property is not available. Additionally, the `position` property can only refer to a physical column, and not a virtual one. #### Transaction ID selection The `proposedTransactionIdSelection` property can be defined immediately upon creating the analysis source. If it is set while entering the transaction ID selection feature then a transaction ID preview will only be generated for that selection, and `transactionIdSelection` property will be updated accordingly. # Analysis Type Configuration Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/analysis-type-configuration An analysis type configuration is the configuration of analysis properties for a given analysis type. Libraries, engagements and analyses all have analysis type configurations as child entities for each of their supported analysis types. When an engagement is created, it will copy the analysis type configuration from the related library, and again when an analysis is created it will copy the analysis type configuration from its related engagement in turn. Analysis type configuration allows configuration of settings related to control points, including grouping and weighting of control points, as well as the selection of related risk ranges. # Analysis Types Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/analysis-types **Analysis types** describe the features of each analysis, such as specific account mappings or whether the analysis supports fund accounts, as well as the source configurations used for a given analysis type. [Learn more about the types of analyses available within MindBridge](https://support.mindbridge.ai/hc/en-us/articles/360058198913-Analysis-types-available-in-MindBridge) # API Tokens Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/api-tokens **API tokens** are used to authenticate requests made to the MindBridge API. During creation, each token is assigned permissions that control the actions it can perform. API tokens are valid until their expiry date, after which they can no longer be used. A token may be active for a maximum of 2 years from the date of creation. Additionally, API tokens can be configured to limit access to specific IP addresses or CIDR blocks by setting the `allowedAddresses` property to a valid IPv4 or IPv6 address, or CIDR range. ## API Token Users Once an API token is created, an **API Token User** is automatically created and assigned to the API token. This non-human user account represents the API token, and any action that the API takes will be attributed to that user. Because each API Token User is linked to a unique API token, these accounts cannot be deleted or disabled, except by deleting the associated API token itself. # Async Results Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/async-results **Async results** can be used to track the status of asynchronous background jobs (such as data ingestion) for which results may not be immediately available. Users can poll these records to view the status of their requests. Once the requests have been completed, users can call the relevant entity’s `Read` endpoint to view the results of the job. ### Permissions The **permissions** needed to access this collection are controlled by the target data you are attempting to access. # Chunked Files Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/chunked-files Importing **chunked files** allows you to bypass the 8 GiB import limit by splitting a large file into smaller files (“chunks”). Each chunk can be individually retried in case of a network failure, but the entire import process must be completed within 7 days. ### How it works: * Create a chunked file. * Add chunked file parts. * Create a file manager file from a chunked file. # Connection Tables Results Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/connection-tables-results **Connection Tables Results** represent the outcome of running a Connection's "Get Tables" operation. The Connection Tables Result is stored as a record containing the total number of tables found. The individual tables discovered are stored as separate Connection Table records linked back to this Connection Tables Result. **Notice**: This endpoint is part of a feature under active development. It may be subject to change in future releases. For more information, please contact your MindBridge account representative. # Connection Test Results Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/connection-test-results **Connection Test Results** represent the outcome of running a Connection's "Test Connection" operation. The Connection Test Result is stored as a record containing a message indicating whether the connection was successful or describing the failure. #### Cleanup task A cleanup task is regularly run that will delete Connection Test Results that are older than 7 days. **Notice**: This endpoint is part of a feature under active development. It may be subject to change in future releases. For more information, please contact your MindBridge account representative. # Connections Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/connections **Connections** represent external data sources configured in MindBridge. Connections allow you to connect to external systems, test connectivity, discover available tables, and retrieve data for use in MindBridge. The following types of connections are currently available: * `DATABRICKS` - A connection to a Databricks workspace. This requires a Databricks Authorization entity to be associated with this connection to provide configuration and authorization parameters. **Notice**: This endpoint is part of a feature under active development. It may be subject to change in future releases. For more information, please contact your MindBridge account representative. # Data Catalog Entries Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/data-catalog-entries **Data catalog entries** are curated remote and local data sets accessible in MindBridge. These data sets can be annotated on the table and column level and can be queried to produce a data table. Currently, the following data sources can be used to create data catalog entries: **MindBridge data tables** A data catalog entry can reference an existing MindBridge data table. These catalog entries must have their `source` field set to `DATA_TABLE`, and a valid `dataTableId` set to a data table ID. Data catalog entries can use all data tables accessible by the API as sources. **Connection tables** Tables provided by the connections feature can be used in data catalog entries. These catalog entries must have their `source` field set to `CONNECTION`, and both connectionId and tableId values set. Data catalog entries are not actively validated for alignment with their underlying source and may need to be manually validated and corrected if the remote source’s schema is not compatible with the schema provided by the data catalog entry. The data catalog does not need to include all columns provided by the remote source, but the name and columnType fields of the columns must align with the underlying source name and type respectively. Columns that are not nullable in the source may not be nullable in the data catalog. Failure to properly align the column schemas may result in errors when attempting to read data from the data catalog entry. Data types are not implicitly converted, so the exact same data types must be present in the data source and the data catalog entry. **Data Flows** Using a data flow as a source allows transformations to be applied to an existing data catalog entry. Catalog entries that are created from a data flow must have their `source` field set to `DATA_FLOW`, and a valid `dataFlowId` set to a data flow ID. Data flows and catalogs cannot be connected in such a way that would cause a circular dependency. Attempting to do so will result in an error during validation or when attempting to import data. **Notice**: This endpoint is part of a feature under active development. It may be subject to change in future releases. For more information, please contact your MindBridge account representative. # Data Connection Tables Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/data-connection-tables **Connection Tables** represent individual tables discovered from an external connection. When a Connection's "Get Tables" operation is performed, the results are stored as Connection Table records. Each record contains the table's identifier, display name, and schema (column definitions), and is linked back to both the Connection and the Connection Tables Result that produced it. If the "Get Tables" operation is run multiple times on the same Connection, tables are added, removed, or updated based on their `tableId`, rather than creating duplicate entries. **Notice**: This endpoint is part of a feature under active development. It may be subject to change in future releases. For more information, please contact your MindBridge account representative. # Data Flows Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/data-flows **Data Flows** are used to transform the data provided by a data catalog entry. The data catalog from which to pull data is defined by the `inputDataCatalogEntryId` parameter and is then transformed in order by the data flow operations defined by the `operations` parameter. Data flows themselves don’t have an explicitly defined schema but can be queried for data or used as a source for a data catalog, similar to data tables or connections. The schema of data produced is determined by the transformations applied. The following data flow operations are available: **Remap** - `"type": "REMAP"` Changes the column names identified by the list of source/destination pairs. This can be used to rename existing columns. The same column can be remapped into multiple output columns, effectively duplicating it. Columns that are not defined in the operation will not be included in the output. To include a column without renaming it, you must set both the source and destination to the original column name. Multiple sources cannot be mapped to the same destination. **Notice**: This endpoint is part of a feature under active development. It may be subject to change in future releases. For more information, please contact your MindBridge account representative. # Data Source Import Tasks Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/data-source-import-tasks **Data source import tasks** are records of in-progress or past data source import jobs where data is being imported into MindBridge from a local or remote data source. **Notice**: This endpoint is part of a feature under active development. It may be subject to change in future releases. For more information, please contact your MindBridge account representative. # Data Tables Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/data-tables After running the analysis, the **data table** provides results details about the imported financial data for the current period. ### Logical names and types Data tables types can be identified by either their `logicalName` or `type` field, depending on the data table, and can be queried accordingly using the following fields: | Table | Field | Value | | - | - | - | | General Ledger Entries | `logicalName` | `gl_journal_lines` | | General Ledger Transactions | `logicalName` | `gl_journal_tx` | | Monetary Flows | `type` | `flows_compact` | | Accounts Payable Entries | `logicalName` | `ap_detail_entries` | | Accounts Receivable Entries | `logicalName` | `ar_detail_entries` | | Accounts Payable: End of Period Outstanding Payable | `logicalName` | `ap_detail_union_open_payables` | | Accounts Receivable: End of Period Outstanding Receivables | `logicalName` | `ar_detail_union_open_receivables` | | Configured Analysis Entries | `logicalName` | `output_entries_virtual` | ### Table API stability The API includes data tables with stable schema as well as tables with unstable schema, where the schema might change in the future or may even be removed. By default, the data table query API returns tables with stable schema only. To include tables with unstable schema in the results, add `include-unstable-schemas=true` to your query string. For example, `https://.../api/v1/data-tables/query?page=0&size=20&include-unstable-schemas=true`. # Data Transformation Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/data-transformation The **data transformation** endpoint is a collection of data manipulation techniques that can be performed on file manager files. These transformations can be applied to one or more files, and typically generate new files based on specified input configurations. # Databricks Authorization Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/databricks-authorization **Databricks Authorizations** store the credentials and configuration required to authenticate with a Databricks instance. Each authorization is associated with a Connection and contains the host, HTTP path, and authentication details (either a personal access token or OAuth 2.0 machine-to-machine credentials). Each Connection can have at most one Databricks Authorization — creating a new authorization for a Connection that already has one will fail. The `authType` field determines which credentials are required: * **PAT** (Personal Access Token): Uses `host`, `httpPath`, and `accessToken`. The `port` is optional (typically 443). * **OAUTH\_M2M** (OAuth 2.0 Machine-to-Machine): Uses `host`, `httpPath`, `clientId`, and `clientSecret`. The `port` is optional (typically 443). **Notice**: This endpoint is part of a feature under active development. It may be subject to change in future releases. For more information, please contact your MindBridge account representative. # Engagement Account Groupings Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/engagement-account-groupings An **engagement account grouping** is an engagement-level copy of an account grouping that is generated upon creation of a new engagement. Subsequent changes made to the original account grouping and/or its account groups will not be copied into the engagement account grouping, and vice versa. # Engagement Account Groups Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/engagement-account-groups An **engagement account group** is an individual entry within an engagement account grouping. # Engagements Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/engagements An **engagement** represents a service or activity performed for one of your clients. When you create an engagement within an organization, it will always be associated with that organization. Engagements house the analyses you run within MindBridge, like the general ledger analysis. Typically engagements represent an annual audit, so using MindBridge over the course of several years will result in multiple engagements within an organization, each corresponding to a fiscal year. The reportingPeriodConfigurationId is an optional field. If provided, it will use the custom reporting period configuration specified by the ID. If not provided, it will default to the default reporting period configuration. # File Info Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/file-info *File Info* is an entity used to describe metadata for a file within the MindBridge application. Every file has an associated File Info record. If the system detects tabular data in the file, the File Info is automatically upgraded to a Tabular File Info, which includes additional metadata describing the table and columns. The type of file info is determined by the `type` field. If the value is `FILE_INFO`, the record is a file info. If the value is `TABULAR_FILE_INFO`, the record is a tabular file info. # File Manager Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/file-manager The **file manager** is a secure, centralized holding area designed to store files related to an engagement. It supports a folder-based hierarchy, allowing data to be utilized for various purposes. Files stored in the file manager can be imported into appropriate analysis sources\*. \***Note:** The file manager can hold any number of files, but the analysis source types available within an engagement are controlled by the selected library and the analysis types it supports. # File Results Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/file-results **File results** are the results of asynchronous processes that produce files. They can be exported once the async result reports that the task is complete. File results are restricted to the API token that started the export process. File results created by another user or API token cannot be accessed. # GDPdU Unpack Jobs Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/gdpdu-unpack-jobs GDPdU Unpack Jobs record asynchronous archive unpack operations and the File Manager files and directories they create. # JSON Tables Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/json-tables A JSON Table is a collection of tabular data structured into one or more pages of JSON arrays, imported into the MindBridge platform. Each array consists of objects, where for each object, the keys represent column headers and their associated values represent the data for that column. Data must be uploaded sequentially, one page at a time, as concurrent page uploads are not supported. Once all data has been appended to the JSON Table, a file manager file can be created using the file manager's `Import From JSON Table` endpoint, which merges all the parts into a concatenated CSV file. The headers in the resulting file are based on those specified in the JSON Table, and the order of the headers will correspond to the sequence in which each unique header appears in the source data. For example, given the following two pages of JSON Table data: ```json theme={null} [ { "Account": "First Account", "Amount": "10.11$", "Date": "2020-01-01" }, { "Account": "Second Account", "Amount": "89.99$", "Date": "2020-01-02" } ] ``` ```json theme={null} [ { "Account": "Third Account", "Amount": "33.31$", "Date": "2020-01-03" }, { "Account": "Fourth Account", "Amount": "10.11$", "Memo": "My Memo" } ] ``` The resulting CSV file would be the following: ``` "Account","Amount","Date","Memo" "First Account","10.11$","2020-01-01","" "Second Account","89.99$","2020-01-02","" "Third Account","33.31$","2020-01-03","" "Fourth Account","10.11$","","My Memo" ``` ### JSON Table entities cleanup JSON Table entities that are more than **7 days** old will be deleted. To avoid data loss, ensure that all JSON Table entries are imported as file manager files once all the data has been imported. # Libraries Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/libraries **Libraries** allow teams to standardize their engagements firm-wide by setting the parameters for each type of analysis available in MindBridge, including account groupings, ratios, filters, and risk scores. New libraries must be created based on an existing library (i.e., a “base library”). When a base library is selected, its point-in-time settings and permissions are copied to the new library. The following system libraries can be selected as base libraries: * MindBridge for-profit * MindBridge not-for-profit * MindBridge not-for-profit with funds * MindBridge review # Organizations Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/organizations **Organizations** represent each business/client/company/entity that you analyze with MindBridge. Organizations house all of your client’s engagements (audit/analysis), account mappings, and any other data imported into MindBridge for that client. # Populations Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/populations **Populations** allow users to group entries within an analysis to support more efficient sampling. Unique populations can be defined within libraries, engagements, and analyses, and can be used to surface or exclude groups of entries from the analysis results. Some fields (below) within population entities may only be defined for populations depending on their parent entity. Library populations: * `libraryId` Engagement populations: * `engagementId` * `derivedFromLibrary` * `disabledForAnalysisIds` * `promotedFromAnalysisId` Analysis populations: * `analysisId` * `derivedFromEngagement` Each population inherits permissions from its parent entity type. In order to access library, engagement, and analysis populations, you will need to be able to access libraries, engagements, and analyses respectively. If the API token does not provide sufficient access, those populations will be excluded from `GET` and /`query` results. ### Population conditions Populations use the same condition format as saved filters. Please refer to the saved filters documentation for a description on how the condition formats work. Population conditions have additional restrictions in addition to those applied to saved filters: * The following fields cannot be used as part of a population condition: `populations`, `account_tags_decreasing`, `account_tags_increasing`, `status` and `risk_range`. * Populations can only be applied to general ledger analysis types. Unlike filters, populations are validated on creation and when updated. A create or update to a population condition that doesn't align with the analysis' data table definition will fail. Additionally, unlike filters, populations can only be applied to general ledger entries, not transactions. Similar to filters, populations include the fields `legacyFilterFormat`, `displayCurrencyCode` and `displayLocale`, which function in the same way as they do for saved filters. # Reporting Period Configuration Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/reporting-period-configuration **Reporting period configurations** allow users to define specific reporting periods for analyses. Creating a reporting period configuration requires both monthly and weekly reporting periods to refer to the same date ranges. The monthly reporting period entries should include the period number, quarter number, the year, start date, and end date for each period. Similarly, the weekly reporting period entries should contain the week number, year, start date, and end date. # Risk Ranges Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/risk-ranges Risk ranges are customized scoring parameters for grouping risk scores into low, medium, and high risk range bounds. Each risk range bound has a low threshold and a high threshold. These values represent percentage values with two-decimal precision. The thresholds are `PERCENTAGE_FIXED_POINT` values, which are percentages with two decimal places, represented as numbers from 0 to 10,000. For more details on this data format, refer to the Data Formats section of the API reference. You are not required to utilize all risk range bounds, however you must define at least two ranges. The values must be continuous with no gaps, and no overlapping values. If a low risk range has a high threshold of 15% (represented as `1500`), the low threshold of the next risk range must start at 15.01% ( represented as `1501`). Risk ranges are designed to be used in conjunction with analysis type configurations. Risk ranges can only be added to libraries, and are copied onto new engagements that select the library when created. Once copied to the engagement, the risk range can no longer be updated. # Risk Segmentation Configs Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/risk-segmentation-configs **Risk segmentation configurations** are saved views for the Risk Segmentation dashboard on an analysis. Each config describes how results should be broken down (the **segments**), which summary **columns** appear in the table, and optional dashboard **filters**. Configs correspond to the segment picker in the web application. This API manages those saved configurations only. It does **not** return dashboard table data or support drilling into entries. (The web app loads table rows through separate private endpoints.) Each config belongs to one analysis. `analysisId` is the analysis **run** id (the same id returned by `/v1/analyses` for the run, not the analysis context id). Names must be unique within an analysis. ### Typical workflow 1. **Create** a config with `analysisId`, a unique `name`, ordered `segments`, and ordered `columns`. 2. **Query** configs for an analysis (for example `{ "$eq": ["analysisId", ""] }`). 3. **Read** a config by id when you need the full definition. 4. **Delete** configs you no longer need. There is no update operation on the public API. To change a config, delete it and create a new one. ### Segments `segments` is an ordered list. Order defines the hierarchy shown in the dashboard table (outer segments first, inner segments nested beneath them). Each value must be a valid SQL identifier. **`risk_score` is required** in `segments`. Create requests without it are rejected. #### Built-in segment keys (general ledger and similar analyses) | Segment | Meaning | | - | - | | `risk_group` | Risk assertion category (for example asset vs profit-and-loss assertion scores). | | `risk_score` | Individual risk score (ensemble). **Required.** | | `account_l1` … `account_l5` | Account grouping hierarchy levels. Use only levels that exist for the analysis. | | `population_` | Group by a population tag code (prefix is literal `population_`). | | `category_` | Group by a population category code (prefix is literal `category_`). | The web application builds population segment ids from enabled populations on the analysis. #### Custom analysis segments For custom (flex) analyses, additional segment fields may be used when they name **categorical** columns on the analysis entry data table. Those names must be valid SQL identifiers and must exist on the table. The analysis designer uses the same rules when defining risk segmentation there. ### Columns `columns` is an ordered list of metric fields displayed in the dashboard table for each segment row. Values must match the snake\_case ids below (these are the same ids the web application sends as `columns`). #### Count and value summaries | Column | Meaning | | - | - | | `total_count` | Entry count in the segment. | | `total_value` | Total monetary value. | | `total_value_dr` | Total debit value. | | `total_value_cr` | Total credit value. | | `net_activity` | Net activity value. | | `risk_avg` | Average risk score in the segment. | #### High / medium / low counts and values | Column | Meaning | | - | - | | `high_count`, `medium_count`, `low_count` | Entry counts at each risk level. | | `high_value`, `medium_value`, `low_value` | Monetary totals at each risk level. | | `high_value_dr`, `high_value_cr`, … | Debit/credit splits of H/M/L value columns (same pattern as above). | #### High / medium / low percentages | Column | Meaning | | - | - | | `percent_high_risk`, `percent_med_risk`, `percent_low_risk` | Percent of entries at each risk level. | | `percent_high_risk_dr`, `percent_high_risk_cr`, … | Debit/credit splits of the percentage columns (same pattern). | Debit/credit column variants apply to general ledger analyses that expose separate debit and credit totals. Omit them when not relevant to the analysis type. Do **not** put segment keys (such as `risk_group` or `account_l1`) in `columns`; those belong in `segments`. ### Optional filters These fields mirror the **Risk group** and **Risk score** filters on the dashboard facet bar. They restrict which scores and categories are in scope when the config is opened. They do not add extra grouping levels. | Field | Meaning | | - | - | | `riskScoreIds` | Risk score ids (ensemble object ids) to include. When omitted or empty, all enabled risk scores for the analysis are in scope. When `risk_score` is not a segment, this still limits which scores contribute to aggregated columns. | | `riskGroups` | Risk group category names to include (for example `GENERAL`, `ASSETS`, `PROFIT_LOSS`, or a custom risk score category name). When omitted or empty, all groups are in scope. | `riskGroups` values are **category labels**, not risk range ids and not entries from `/v1/risk-ranges`. ### Other fields | Field | Meaning | | - | - | | `displayCellVisuals` | When `true`, the dashboard shows in-cell sparkline visuals for numeric columns. Defaults to `false`. Maps to internal `displayTableSparklines`. | | `enabled` | Whether the config is active. Defaults to `true`. Disabled configs remain stored but are not selected by default in the web application. | | `analysisTypeId` | Set automatically on create from the analysis. Returned on read and query; do not send on create. | ### Example create request ```json theme={null} { "analysisId": "123456789012345678901234", "name": "Risk group and score", "segments": ["risk_group", "risk_score"], "columns": ["total_count", "total_value", "risk_avg"], "displayCellVisuals": false, "enabled": true, "riskScoreIds": ["abcdefabcdefabcdefabcd"], "riskGroups": ["GENERAL", "PROFIT_LOSS"] } ``` ### Validation * `analysisId` must reference an existing analysis run. * `name` must be unique among configs for that analysis. * `segments` must include `risk_score`. * Segment and column names must be valid SQL identifiers. * Invalid segment or column combinations for the analysis type may be rejected at create time. ### Query See the query operation description for filterable fields. # Saved Filters Source: https://developer.mindbridge.ai/api-explorer/tag-descriptions/saved-filters **Saved Filters** are used to filter data tables in order to easily and repeatedly extract insights on large sets of data. The saved filters endpoint allows for easy creation and management of saved filters, and validation of the applicability of filters across different data tables and even across engagements and organizations. Saved filters contain **conditions**, which are definitions on how the filter applies constraints on the underlying data table. These conditions contain a field, type and various parameters depending on the condition type. The field can either specify a column in the data table (with some constraints), or a special case field name, which provides the ability to filter the data table on features of the dataset that are not represented by a specific column. The condition type determines how the data will be filtered. Which types can be applied depends on the data table's column type and other properties. For special case filters the type parameters depend on the underlying data table and analysis features. See the *Condition Types* section for more details. Saved filters can be used to filter general ledger, accounts payable, and accounts receivable analyses. They cannot be used as part of custom analysis types. ### Validation Saved filters are different from other entities in the MindBridge API in that the filter conditions are not immediately validated upon creation. This is because they may or may not be applicable to different target data tables based on the analysis features and the column present in the data table, and their types. To validate whether a given filter is compatible on a target data table a `/validate` endpoint is provided, which will return a list of errors and warnings explaining incompatibilities between the provided filter and the target data table. ### Display fields Saved Filter conditions include various fields that are used in generating a description of the filter for each condition. This description is visible in the web application and presents the filter in plain English. In the web application, filters can only be created in either a library or analysis context, and have immediate context with which to base the display fields on. The API doesn't require this context, and can therefore create filters in contexts the web application can't, such as on an organization or engagement without any analyses. In order to generate a sensible filter description for use in the web application, users of the API can optionally provide these values, and verify if they align with a target data table using the `/validate` endpoint. ### Filter types Filters can be of one of four types: `LIBRARY`, `ORGANIZATION`, `ENGAGEMENT` and `PRIVATE` Library, organization, and engagement types determine which parent entity type the filter is stored under, and in some cases restrict which fields can be used on those filters. Private filters function like organization filters, but they are only accessible by the user that created them. This also applies to the API users, who can only see private filters created by that same token user. The API cannot be used to access private filter created by other users, including other token users. ### Filter data type Filter data type is used to determine what kind of data the filter intends to target, and can be set to the values: `TRANSACTION_FILE`, `ENTRIES_FILE` or `LIBRARY_ADMIN_TABLE`. The `TRANSACTION_FILE` value corresponds to the transactions data table in a general ledger analysis. The `ENTRIES_FILE` corresponds to a general ledger, accounts payable and accounts receivable entries tables. ### Disallowed fields The following fields cannot be used as conditions: * `account`, if the analysis is a general ledger analysis * `accounts` or `mac_hierarchy`, if the data table column type is `ARRAY_STRINGS` * `txid`, `rowid` or `matched_entry_id`, if the data table column type is `INT64` * `total_amt`, if the data table column type is `MONEY_100` * `invoice_paid_zero_date`, if the data table column type is `DATE_TIME` * Any data table column whose field name starts with "`cp_score_`" * Any data table column whose field name starts with "`risk`", and has data table column type `PERCENTAGE_FIXED_POINT` * Any column that does not have a data table column type of `KEYWORD_SEARCH` or `LEGACY_ACCOUNT_TAG_EFFECTS`, and without one of `equalitySearch`, `rangeSearch` and `containsSearch` being `true` ### Condition types Condition's types are determined by their `type` field. Some condition types also contain subtypes, which further determine what fields are required to configure them. Broadly there are 2 types of conditions: Group type conditions, and value conditions. Group conditions don't require a field or other properties, and instead contain a sub-list of conditions that are applied against the data table entries. Value conditions filter a specific field and cover all other condition types other than `GROUP`. In addition to `field` they have the following properties: * `fieldLabel` - An optional display name for the field which is used in the full condition description. * `negated` - When `true` the condition will instead exclude any entry that matches the condition from the result. * `fullConditionDescription` - A description of the filter in plain English, using the provided display values such as `fieldLabel` and others. #### `GROUP` type conditions Group conditions, also known as rules, don't require a field, and contain both an operator and a list of conditions. The operation can be either `AND` or `OR`, and the condition will match records that meet all or any of the conditions, depending on the operator. Group conditions can be nested, and the value of the `condition` field on a saved filter must be a group condition, though it can be either type. ```json theme={null} { "type": "GROUP", "operator": "AND", "conditions": [ ... ] } ``` #### `STRING` type conditions String type conditions compare a field against a specific string value. This condition can only be applied to the following special case fields: | **Field** | **Name** | **Allowed Values** | **Notes** | | - | - | - | - | | `accountScoping` | Account Scoping | SIGNIFICANT, INSIGNIFICANT, UNSCOPED | Only allowed on general ledger analyses. | | `riskGroup` | Risk Group | Not `GENERAL` or `MindBridge Score`

ASSETS, LIABILITIES\_EQUITY, PROFIT\_LOSS, or any custom account group by `category` name. | Only allowed on general ledger analyses. | #### `STRING_ARRAY` type conditions String array conditions compare the field against a set of string values. It can be applied to any data table column with the following properties: * Data table column type is `STRING` and `caseInsensitivePrefixSearch` is `true`. * Data table column type is `KEYWORD_SEARCH`. #### `CONTROL_POINT` type conditions Control point conditions match a set of selected control points within their respective high, medium and low risk scores. The control point type can only be used with the field `cp_failed` and when the data table column type is `BOOLEAN_FLAGS`. The `riskLevel` property can be set to `HIGH_RISK`, `MEDIUM_RISK` or `LOW_RISK`. The `controlPoints` contains a list of control point selection models, with the following properties: * `id` - The unique ID of the control point prefixed with `custom_`, in the case of custom control points, or the symbolic name, in the case of MindBridge control points. * `name` - The display name of the control point. Optional. * `symbolicName` - The symbolic name of the control point. In the case of custom control points it must be the symbolic name of the underlying MindBridge control point. * `isRulesBased` - Must be `true` if the target control point is rules based. Rules based control points can only have high and low risk values, and therefore cannot be selected with a `riskLevel` of `MEDIUM_RISK`. Here is an example of both a MindBridge and a custom control point: ```json theme={null} { "type": "CONTROL_POINT", "field": "cp_failed", "fieldLabel": "Control point", "negated": false, "riskLevel": "HIGH_RISK", "controlPoints": [ { "id": "custom_682fab332f732c4d0b8d1ced", "name": "Expert Rules - Example Custom Control Point", "symbolicName": "journal_entry_flat_expert_flow_v2", "rulesBased": false }, { "id": "journal_entry_two_digit_benford_v2", "name": "2 Digit Benford", "symbolicName": "journal_entry_two_digit_benford_v2", "rulesBased": false } ] } ``` #### `ACCOUNT_NODE_ARRAY` type conditions Account node array type conditions match an entry if it's within an account group or specific account code within varying contexts. This condition type can only be used for general ledger analyses. The following fields use the account node array type: | **Field** | **Name** | **Notes** | | - | - | - | | `account_hierarchy_codes` | Account | Matches if the entry is associated with an account within the selection of accounts. | | `increasingCredits` | Increasing Credits | Matches if the entry is associated with an account within the selection of accounts and the credit value within those accounts are increasing. | | `increasingDebits` | Increasing Debits | Matches if the entry is associated with an account within the selection of accounts and the debit value within those accounts are increasing. | Both `increasingCredits` and `increasingDebits` are special case fields and can be used even if they are not present as data table columns. When using an `ACCOUNT_NODE_ARRAY` condition a list of account selections must be provided with the following properties: * `name` - The display name of the account. Optional. * `code` - The account group or account ID of the account. * `useAccountId` - If `true` the condition should match the account id from the account mapping instead of the account group ID for this selection. Here is an example of a condition that matches both an account group and a mapped account: ```json theme={null} { "type": "ACCOUNT_NODE_ARRAY", "field": "increasingCredits", "fieldLabel": "Increasing credits", "negated": false, "accountSelections": [ { "name": "Assets", "code": "1000", "useAccountId": false }, { "name": "Accounts Payable", "code": "21011", "useAccountId": true } ] } ``` #### `TYPEAHEAD_ENTRY` type condition The typeahead entry type condition can be used to match one or more string values within a known set of allowed values. They are used both to filter columns that have been mapped to certain MindBridge field and additional columns marked as filterable. There are also additional special case field that can be used for various purposes. | **Field** | **Name** | **Notes** | | - | - | - | | `status` | Status | Matches entries which contain corresponding tasks with the selected statuses. | | `memo` | Suspicious keyword | Allowed values are from the Suspicious keyword control point. | | `entriesFundRestriction` | Fund restriction | Allowed values are `restricted`, `unrestricted` and `none` | | `transactionsFundRestriction` | Fund restriction | Allowed values are `restricted`, `unrestricted`, `both` and `none` | | `account_tags_increasing` | Increasing account tags | Matches entries whose accounts using the provided account tags have increased in value. | | `account_tags_decreasing` | Decreasing account tags | Matches entries whose accounts using the provided account tags have decreased in value. | In addition to the above field, any data table column with the type `STRING` or `ARRAY_STRINGS` and an ID set for `typeaheadDataTableId` can be used in a typeahead entry condition. The allowed values for typeahead based fields are any of the values present in the column. Typeahead column values are not currently validated, so no warnings will be produced if a value that is not present in the column is used as an entry. A value selection for a typeahead entry has three properties: `lookupId`, which is the value being selected, `displayName`, which is the display name of the underlying value, and `hideLookupId`, which hides the lookup ID when displaying the full display name. Here is an example of a typeahead entry condition: ```json theme={null} { "type": "TYPEAHEAD_ENTRY", "field": "entriesFundRestriction", "fieldLabel": "Fund restriction", "negated": false, "values": [ { "lookupId": "none", "displayName": "No fund information", "hideLookupId": true }, { "lookupId": "restricted", "displayName": "Restricted funds", "hideLookupId": true } ] } ``` #### `POPULATIONS` type condition The populations type condition matches any entries that are within the provided populations. Population type conditions can only be used in general ledger analyses, and can only be used in saved filters at the analysis level. Populations type conditions must use the special case field `population`. Population type conditions can only be applied to general ledger analyses. To include a population in the condition it simply needs to be added to the `populationIds` field. In addition to IDs, population category names can be present in the population IDs list for display purposes. Here is an example of a populations filter: ```json theme={null} { "type": "POPULATIONS", "field": "population", "fieldLabel": "Population", "negated": false, "populationIds": [ "Custom Category", "67d06587edfa507f5e80c7c2" ] } ``` #### `RISK_SCORE` type condition A risk score condition matches entries whose risk score falls within the constraints configured in the condition. The specific risk score being tested is selected by setting the `riskScoreId` field to the field of the target risk score, as found in the data table column metadata. Risk scores are used on the special case fields `riskScoresHml` or `riskScoresPercentage`, depending on the library configuration for the analysis. Additionally, the `riskScoreType` must be set to `HML` or `PERCENT` accordingly. For HML type risk score conditions a set of the values `HIGH`, `MEDIUM`, `LOW` or `UNSCORED`, which match entries that fall within the configured risk range for the selected risk score. Here is an example of a HML risk score filter on a custom risk score: ```json theme={null} { "type": "RISK_SCORE", "field": "riskScoresHml", "fieldLabel": "Risk score", "negated": false, "riskScoreType": "HML", "riskScoreId": "risk_67d2f16d9ffead02b4f54aad", "riskScoreLabel": "My custom risk score", "values": [ "MEDIUM", "UNSCORED" ] } ``` For percentage risk score conditions a `riskScorePercentType` of `MORE_THAN`, `LESS_THAN`, `BETWEEN`, `CUSTOM_RANGE` or `UNSCORED` is set. These determine how the rule will be applied, and which parameters can be set. For `UNSCORED` only entries that haven't been scored are matched. For `MORE_THAN` and `LESS_THAN`, a `value` parameter must be set with a number from 0 to 10,000, representing a percentage between 0% to 100%, and matching entries with scores above or below the specified value. For `CUSTOM_RANGE` a pair of percentage values `rangeStart` and `rangeEnd` are set. Any entries whose score falls between the values will be matched. `BETWEEN` is functionally equivalent to custom range, with the restriction that the `rangeStart` and `rangeEnd` must equal the start and end values of one of the risk score's risk range entries (high, medium or low risk). In the web application this is represented as the user selecting an existing risk range, rather than manually entering a pair of percentages as custom range requires. Here is an example of a percentage risk score filter: ```json theme={null} { "type": "RISK_SCORE", "field": "riskScoresPercentage", "fieldLabel": "Risk score", "negated": false, "riskScoreType": "PERCENT", "riskScoreId": "risk", "riskScoreLabel": "MindBridge score", "riskScorePercentType": "MORE_THAN", "value": 0 } ``` #### `MONETARY_FLOW` type condition The `MONETARY_FLOW` type condition matches entries that are part of a monetary flow corresponding to the filter's configuration. This condition type can only be used in general ledger analyses. Only the special case field `monetarySpecificFlow` can be used with this condition type. The property `monetaryFlowType` must be set to one of the following values, which determine what kind of flow to include entries from: `SIMPLE_FLOW`, `COMPLEX_FLOW` or `SPECIFIC_FLOW`. For simple and complex flow values, entries that are part of simple account to account flows, or flows that are too complex to assign to an account are included. For specific flows a pair of credit and debit account selections, `creditAccount` and `debitAccount` accordingly are set. These use the same parameters as the account node array condition. In addition, the code may be set to `complex` to match flows whose credit or debit account is determined to be too complex to match. Additionally for specific flows a value for `specificMonetaryFlowType` must be set, which further filters the entries based on the specific value of the flow. The following values can be used: * `SPECIFIC_VALUE` - by setting the `value` field to a currency amount only entries whose flow amount matches the value exactly will be matched. * `MORE_THAN` - by setting the `value` field to a currency amount only entries where the flow value exceeds that amount will be matched. * `BETWEEN` - a pair of `rangeStart` and `rangeEnd` values only entries whose value is between the specified currency amounts. Currency amounts are expressed as integers, and do not include decimal places. They follow the same formatting rules as `MONEY_100` fields. See the *Data Formats* section for more information. Here is an example of a monetary flow condition: ```json theme={null} { "type": "MONETARY_FLOW", "field": "monetarySpecificFlow", "fieldLabel": "Monetary flow", "negated": false, "monetaryFlowType": "SPECIFIC_FLOW", "creditAccount": { "name": "Flows too complex to determine a match", "code": "complex", "useAccountId": false }, "debitAccount": { "name": "Operational assets", "code": "1100", "useAccountId": false }, "specificMonetaryFlowType": "BETWEEN", "rangeStart": 0, "rangeEnd": 1037979412 } ``` #### `MONEY` type condition The money type condition matches entries whose value for the provided field is within the configured bounds of the condition. The money type condition can be applied to any field with a data table column type of `MONEY_100`. The following `monetaryValueType` values can be used to configure how the entries are matched: * `MORE_THAN` - Matches entries whose value is more than the configured `value` field. * `LESS_THAN` - Matches entries whose value is less than the configured `value` field. * `SPECIFIC_VALUE` - Matches entries whose value is equal to the configured `value` field. * `BETWEEN` - Matches entries whose value is between the provided `rangeStart` and `rangeEnd` values. The values for `value`, `rangeStart` and `rangeEnd` follow the same formatting rules as the `MONEY_100` data type. Here is an example of a money type condition: ```json theme={null} { "type": "MONEY", "field": "bs_delta", "fieldLabel": "Balance sheet impact", "negated": false, "monetaryValueType": "MORE_THAN", "value": 0 } ``` #### `MATERIALITY` type condition The materiality type condition matches entries that are above, below or above a percentage of the threshold. The materiality type condition can be applied to general ledger analyses with a materiality judgment value set, and can only be applied to the special case `materiality` field. The following `materialityOption` values can be used to configure how the entries are matched: * `ABOVE` - Matches entries whose value is above the materiality threshold. * `BELOW` - Matches entries whose value is below the materiality threshold. * `PERCENTAGE` - Matches entries whose value is above a percent of the materiality threshold. The percent is a decimal number set in the `value` field, and can be greater than 100%. Here is an example of a materiality type condition, and represents a percentage value of 110.25%: ```json theme={null} { "type": "MATERIALITY", "field": "materiality", "fieldLabel": "Materiality", "negated": false, "materialityOption": "PERCENTAGE", "value": 110.25 } ``` #### `NUMERICAL` type condition The numerical type condition matches entries whose value for the provided field is within the configured bounds of the condition. This condition can be applied to any field with a data table column types of `INT32`, `INT64`, `FLOAT32` and `FLOAT64`. The following `numericalValueType` values can be used to configure how the entries are matched: * `MORE_THAN` - Matches entries whose value is more than the configured `value` field. * `LESS_THAN` - Matches entries whose value is less than the configured `value` field. * `SPECIFIC_VALUE` - Matches entries whose value is equal to the configured `value` field. * `BETWEEN` - Matches entries whose value is between the provided `rangeStart` and `rangeEnd` values. Here is an example of a numerical type condition: ```json theme={null} { "type": "NUMERICAL", "field": "entries_count", "fieldLabel": "Entries count", "negated": false, "numericalValueType": "MORE_THAN", "value": 0 } ``` #### `DATE` type condition The date type condition matches entries whose value for the provided field is within the configured bounds of the condition. The numerical type condition can be applied to any field with a data table column types of `DATE` and `DATE_TIME`. The following `numericalValueType` values can be used to configure how the entries are matched: * `AFTER` - Matches entries whose value is more than the configured `value` field. * `BEFORE` - Matches entries whose value is less than the configured `value` field. *
[...]
